////////////////////////////////////////////////////////////////////////////////
// Code file for Dirty classes
////////////////////////////////////////////////////////////////////////////////

#include "dirty.h"
#include <allegro.h>

// 
// Design
// =============================================================================
//
// =============================================================================
// Classic
// -----------------------------------------------------------------------------
// DirtyList: linked list of "dirtied" rectangles.
// AddList: linked list of rectangle or reactangles from rectangle being
//    added.
// CurrentDirtyRect: pointer to a DirtyList node.
// CurrentDirtyRect: pointer to a AddList node.
//
// =============================================================================
// Pseudo Pseudo-code
// -----------------------------------------------------------------------------
//
// Function: Add
// -------------
// CurrentDirtyRect = DirtyList->head;
// while (CurrentDirtyRect != NULL) {
//    CurrentAddRect = AddList->head;
//    while (CurrentAddRect != NULL) {
//       // +---+--+
//       // |D  |  |
//       // |   |  |
//       // |   |  |
//       // +---+  |
//       // |      |
//       // |     A|
//       // +------+
//       if ((CurrentAddRect->x1 >= CurrentDirtyRect->x1) && (CurrentAddRect->y1 >= CurrentDirtyRect->y1) && (CurrentAddRect->x2 <= CurrentDirtyRect->x2) && (CurrentAddRect->y2 <= CurrentDirtyRect->y2) {
//          // CurrentAddRect contained in or equal to CurrentDirtyRect, allready in list
//          delete CurrentAddRect;
//          CurrentAddRect = AddList->pop(CurrentAddRect);
//       }
//       // +----+
//       // |D   |
//       // |    |
//       // |  +-+-+
//       // |  | | |
//       // +--+-+ |
//       //    |  A|
//       //    +---+
//       else if ((CurrentAddRect->x1 >= CurrentDirtyRect->x1) && (CurrentAddRect->y1 >= CurrentDirtyRect->y1) && (CurrentAddRect->x2 > CurrentDirtyRect->x2) && (CurrentAddRect->y2 > CurrentDirtyRect->y2) {
//          DirtyRect *NewRect1 = new DirtyRect(CurrentAddRect->x1, CurrentDirtyRect->y2, CurrentDirtyRect->x2, CurrentAddRect->y2);
//          AddList->push(NewRect1);
//          DirtyRect *NewRect2 = new DirtyRect(CurrentDirtyRect->x2, CurrentAddRect->y1, CurrentAddRect->x2, CurrentAddRect->y2);
//          AddList->push(NewRect2);
//          delete CurrentAddRect;
//          CurrentAddRect = AddList->pop(CurrentAddRect);
//       }
//       // +------+
//       // |D     |
//       // |      |
//       // | +--+ |
//       // | |  | |
//       // +-+--+-+
//       //   | A|
//       //   +--+
// further work else if ((CurrentAddRect->x1 >= CurrentDirtyRect->x1) && (CurrentAddRect->y1 >= CurrentDirtyRect->y1) && (CurrentAddRect->x2 > CurrentDirtyRect->x2) && (CurrentAddRect->y2 > CurrentDirtyRect->y2) {
//          DirtyRect *NewRect1 = new DirtyRect(CurrentAddRect->x1, CurrentDirtyRect->y2, CurrentAddRect->x2, CurrentAddRect->y2);
//          AddList->push(NewRect1);
//          delete CurrentAddRect;
//          CurrentAddRect = AddList->pop(CurrentAddRect);
//       }
//       // +------+
//       // |A     |
//       // | +--+ |
//       // | |  | |
//       // | | D| |
//       // | +--+ |
//       // |      |
//       // +------+
//       else if ((CurrentAddRect->x1 <= CurrentDirtyRect->x1) && (CurrentAddRect->y1 <= CurrentDirtyRect->y1) && (CurrentAddRect->x2 >= CurrentDirtyRect->x2) && (CurrentAddRect->y2 >= CurrentDirtyRect->y2) {
//          DirtyRect *NewRect1 = new DirtyRect(CurrentAddRect->x1, CurrentAddRect->y1, CurrentAddRect->x2, CurrentDirtyRect->y1);
//          AddList->push(NewRect1);
//          DirtyRect *NewRect2 = new DirtyRect(CurrentAddRect->x1, CurrentDirtyRect->y2, CurrentAddRect->x2, CurrentAddRect->y2);
//          AddList->push(NewRect2);
//          DirtyRect *NewRect3 = new DirtyRect(CurrentAddRect->x1, CurrentDirtyRect->y1, CurrentDirtyRect->x1, CurrentDirtyRect->y2);
//          AddList->push(NewRect3);
//          DirtyRect *NewRect3 = new DirtyRect(CurrentDirtyRect->x2, CurrentDirtyRect->y1, CurrentAddRect->x2, CurrentDirtyRect->y2);
//          AddList->push(NewRect4);
//          delete CurrentAddRect;
//          CurrentAddRect = AddList->pop(CurrentAddRect);
//       }
//       else {
//          CurrentAddRect = CurrentAddRect->next;
//       }
//    }
//    CurrentDirtyRect = CurrentDirtyRect->next;
// }
//
