////////////////////////////////////////////////////////////////////////////////
// Header file for Earth class
////////////////////////////////////////////////////////////////////////////////

#ifndef EARTH_H
#define EARTH_H

#include <allegro.h>
#include "dirty.h"

class Earth_element {
public:
   void paint(int _colour) { colour = _colour; }
private:
   int colour;
};

////////////////////////////////////////////////////////////////////////////////
// Class: Earth
////////////////////////////////////////////////////////////////////////////////
class Earth {
public:
   Earth(int _width, int _height);
   ~Earth(void);
   void set_fall_area(int x1, int y1, int x2, int y2);
   void generate(void);
   void update(void);
   void fall(void);
   void draw(BITMAP *bitmap);
   void set_width(int _width);
   void set_height(int _height);
   int get_width(void);
   int get_height(void);
   BITMAP *get_data();
   void set_data(BITMAP *);
   Dirty_list falling;
   Earth_element *map;
private:
   BITMAP *data;
   int width;
   int height;
};

// Earth creation tools
int get_distance(int x1, int y1, int x2, int y2);
void my_do_hline(BITMAP *bmp, int x1, int y, int x2, int color, void (*proc)(BITMAP *bmp, int x, int y, int color));
void my_do_vline(BITMAP *bmp, int x, int y1, int y2, int color, void (*proc)(BITMAP *bmp, int x, int y, int color));
void my_do_line(BITMAP *bmp, int x1, int y1, int x2, int y2, int d, void (*proc)(BITMAP *bmp, int x, int y, int color));
void my_do_rect(BITMAP *bmp, int x1, int y1, int x2, int y2, int color, void (*proc)(BITMAP *bmp, int x, int y, int color));
void my_do_rectfill(BITMAP *bmp, int x1, int y1, int x2, int y2, int color, void (*proc)(BITMAP *bmp, int x, int y, int color));
void my_do_circlefill(BITMAP *bmp, int x, int y, int radius, int color, void (*proc)(BITMAP *bmp, int x, int y, int color));
void my_do_circle(BITMAP *bmp, int x, int y, int radius, int color, void (*proc)(BITMAP *bmp, int x, int y, int color));

#endif
