/////////////////////////////////////////////////////////////////////////////////
// Code file for Explosion class
////////////////////////////////////////////////////////////////////////////////

#include "explosion.h"
#include "main.h"
#include "snd_data.h"
#include <allegro.h>

int Explosion::count = 0;

////////////////////////////////////////////////////////////////////////////////
// Function: Explosion::Explosion
////////////////////////////////////////////////////////////////////////////////
Explosion::Explosion(fix _x, fix _y, fix _radius)
   : Object()
{
   set_type(TYPE_EXPLOSION);
   radius = _radius;
   x = _x;
   y = _y;
   age = 0;
   count++;
   play_sample((SAMPLE *)snd_data[SND_EXPLOSION1 + rand() % 3].dat, 127, 127, 1000, 0);
   colour = rand() % 16;

   // Destroy earth
   circlefill(ground->get_data(), (int)x, (int)y, (int)radius, 0);
   Dirty_rect *new_rect = new Dirty_rect((int)x - (EXPLOSION_SIZE + 1), highest_earth, (int)x + (EXPLOSION_SIZE + 1), (int)y + (EXPLOSION_SIZE + 1));
   ground->falling.push(new_rect);
}

////////////////////////////////////////////////////////////////////////////////
// Function: Explosion::~Explosion
////////////////////////////////////////////////////////////////////////////////
Explosion::~Explosion(void)
{
   count--;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Explosion::update
////////////////////////////////////////////////////////////////////////////////
void Explosion::update(void)
{
   if (age >= radius) {
      exist = FALSE;
   }
   age++;
}

////////////////////////////////////////////////////////////////////////////////
// Function: draw
////////////////////////////////////////////////////////////////////////////////
void Explosion::draw(BITMAP *b)
{
   drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
   color_map = &trans_map;
   for (int i = (int)(radius * 2) - (int)(age * 2); i > 0; i -= (int)(((int)(radius * 2) - (int)(age * 2)) / 4) + 1) {
      circlefill(b, (int)x, (int)y, i, colour);
   }
   drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
}

