////////////////////////////////////////////////////////////////////////////////
// Code file for Joystick class
////////////////////////////////////////////////////////////////////////////////

#include <allegro.h>
#include "joystick.h"

int Joystick::count = 0;

////////////////////////////////////////////////////////////////////////////////
// Function: Joystick::Joystick
////////////////////////////////////////////////////////////////////////////////
Joystick::Joystick(int _number)
{
   number = _number;
   count++;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Joystick::~Joystick
////////////////////////////////////////////////////////////////////////////////
Joystick::~Joystick(void)
{
   count--;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Joystick::poll
////////////////////////////////////////////////////////////////////////////////
void Joystick::poll(void)
{
   h = 0;
   v = 0;
   a = 0;
   b = 0;
   poll_joystick();
   if (joy[number].stick[0].axis[1].d1) { // left
      h--;
   }
   if (joy[number].stick[0].axis[1].d2) { // right
      h++;
    }
   if (joy[number].stick[0].axis[0].d1) { // up
      v--;
   }
   if (joy[number].stick[0].axis[0].d2) { // down
      v++;
   }
   if (joy[number].button[0].b) { // button a
      a++;
   }
   if (joy[number].button[1].b) { // button b
      b++;
   }
}

