////////////////////////////////////////////////////////////////////////////////
// Header file for main.cc
////////////////////////////////////////////////////////////////////////////////

#include <time.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <allegro.h>

#include "tank.h"
#include "missile.h"
#include "earth.h"
#include "explosion.h"
#include "object.h"
#include "input.h"
#include "singlist.h"

#define N_SHOTS 50
#define N_EXPLOSIONS 100

#define EXPLOSION_SIZE 32
#define EXPLOSION_COLOR 4

#define RED 12
#define BLUE 9
#define YELLOW 14
#define GREEN 10

#define GRAVITY 0.1
#define GROUND_START 64

// conv to func
#define LEFT -1
#define RIGHT 1

//globals
extern int highest_earth;

extern BITMAP *background;
extern BITMAP *buffer;
extern int quit;
extern Earth *ground;
extern Singlist<Object> *objects;
extern int screen_width;
extern int screen_height;

extern DATAFILE *game_data;
extern DATAFILE *snd_data;
extern DATAFILE *mus_data;
extern FONT *font_system;
extern FONT *font_title;
extern RGB *palette_system;

extern COLOR_MAP trans_map;
extern COLOR_MAP light_map;

