////////////////////////////////////////////////////////////////////////////////
// Code file for Mouse class
////////////////////////////////////////////////////////////////////////////////

#include <allegro.h>
#include "mouse.h"
#include "main.h"
#include "gamedata.h"

int Mouse::count = 0;

////////////////////////////////////////////////////////////////////////////////
// Function: Mouse::Mouse
////////////////////////////////////////////////////////////////////////////////
Mouse::Mouse(int _mode)
{
   mode = _mode;
   count++;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Mouse::~Mouse
////////////////////////////////////////////////////////////////////////////////
Mouse::~Mouse(void)
{
   count--;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Mouse::poll
////////////////////////////////////////////////////////////////////////////////
void Mouse::poll(void)
{
   if (mode == MOUSE_DIRECT) {
      int _x, _y; // store mouse mickeys
      h = 0;
      v = 0;
      a = 0;
      b = 0;
      get_mouse_mickeys(&_x, &_y);
      if (_x < 0) { // left
         h--;
      }
      if (_x > 0) { // right
         h++;
      }
      if (_y < 0) { // up
         v--;
      }
      if (_y > 0) { // down
         v++;
      }
      if (mouse_b & 1) { // button a
         a++;
      }
      if (mouse_b & 2) { // button b
         b++;
      }
   }
   else if (mode == MOUSE_ICONS) {
      int _x, _y; // store mouse mickeys
      int row;
      int column;
      h = 0;
      v = 0;
      a = 0;
      b = 0;
      get_mouse_mickeys(&_x, &_y);
      x += _x;
      y += _y;
      if (x < -24) {
         x = -24;
      }
      if (x > 24) {
         x = 24;
      }
      if (y < -24) {
         y = -24;
      }
      if (y > 24) {
         y = 24;
      }
      if (x < -8) {
         column = 0;
      }
      else if (x > 8) {
         column = 2;
      }
      else { // x > -8 && x < 8
         column = 1;
      }
      if (y < -8) {
         row = 0;
      }
      else if (y > 8) {
         row = 2;
      }
      else { // y > -8 && y < 8
         row = 1;
      }
      if ((mouse_b & 1) && column == 0) { // left
         h--;
      }
      if ((mouse_b & 1) && column == 2) { // right
         h++;
      }
      if ((mouse_b & 1) && row == 0) { // up
         v--;
      }
      if ((mouse_b & 1) && row == 2) { // down
         v++;
      }
      if ((mouse_b & 1) && row == 1 && column == 1) { // button a
         a++;
      }
      if ((mouse_b & 2) && row == 1 && column == 1) { // button b
         b++;
      }
   }
}

////////////////////////////////////////////////////////////////////////////////
// Function: Mouse::draw
////////////////////////////////////////////////////////////////////////////////
void Mouse::draw(BITMAP *destination, int _x, int _y)
{
   if (mode == MOUSE_DIRECT) {
   }
   else if (mode == MOUSE_ICONS) {
      int row;
      int column;
      int focus_x;
      int focus_y;
      BITMAP *sprite;
      if (x < -8) {
         column = 0;
      }
      else if (x > 8) {
         column = 2;
      }
      else { // x > -8 && x < 8
         column = 1;
      }
      if (y < -8) {
         row = 0;
      }
      else if (y > 8) {
         row = 2;
      }
      else { // y > -8 && y < 8
         row = 1;
      }
      if (column == 0) {
         sprite = (BITMAP *)game_data[CURSOR_LEFT].dat;
         focus_x = 15;
         focus_y = 15;
      }
      else if (column == 2) {
         sprite = (BITMAP *)game_data[CURSOR_RIGHT].dat;
         focus_x = 15;
         focus_y = 15;
      }
      else {
         if (row == 0) {
            sprite = (BITMAP *)game_data[CURSOR_CCW].dat;
            focus_x = 15;
            focus_y = 15;
         }
         else if (row == 2) {
            sprite = (BITMAP *)game_data[CURSOR_CW].dat;
            focus_x = 15;
            focus_y = 15;
         }
         else { // row == 1
            sprite = (BITMAP *)game_data[CURSOR_SELECT].dat;
            focus_x = 15;
            focus_y = 15;
         }
      }
      draw_sprite(destination, sprite, x + _x - focus_x, y + _y - focus_y);
   }
}
