////////////////////////////////////////////////////////////////////////////////
// Code file for Object class
////////////////////////////////////////////////////////////////////////////////

#include "object.h"
#include "input.h"
#include "main.h"

#include "gamedata.h"

int Object::count = 0;

////////////////////////////////////////////////////////////////////////////////
// Function: Object::Object
////////////////////////////////////////////////////////////////////////////////
Object::Object(void)
{
   name = NULL;
   count++;
   exist = TRUE;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::~Object
////////////////////////////////////////////////////////////////////////////////
Object::~Object(void)
{
   if (name != NULL) {
      delete [] name;
   }
   count--;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::get_count
////////////////////////////////////////////////////////////////////////////////
int Object::get_count(void)
{
   return count;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::set_x
////////////////////////////////////////////////////////////////////////////////
void Object::set_x(fix _x)
{
   x = _x;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::set_y
////////////////////////////////////////////////////////////////////////////////
void Object::set_y(fix _y)
{
   y = _y;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::get_x
////////////////////////////////////////////////////////////////////////////////
fix Object::get_x(void)
{
   return x;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::get_y
////////////////////////////////////////////////////////////////////////////////
fix Object::get_y(void)
{
   return y;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::set_x_vel
////////////////////////////////////////////////////////////////////////////////
void Object::set_x_vel(fix _x_vel)
{
   x_vel = _x_vel;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::set_y_vel
////////////////////////////////////////////////////////////////////////////////
void Object::set_y_vel(fix _y_vel)
{
   y_vel = _y_vel;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::get_x_vel
////////////////////////////////////////////////////////////////////////////////
fix Object::get_x_vel(void)
{
   return x_vel;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::get_y_vel
////////////////////////////////////////////////////////////////////////////////
fix Object::get_y_vel(void)
{
   return y_vel;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::set_angle
////////////////////////////////////////////////////////////////////////////////
void Object::set_angle(fix _angle)
{
   angle = _angle;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::get_angle
////////////////////////////////////////////////////////////////////////////////
fix Object::get_angle(void)
{
   return angle;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::set_name
////////////////////////////////////////////////////////////////////////////////
void Object::set_name(char *_name)
{
   if (name != NULL) {
      delete [] name;
   }
   name = new char[strlen(_name) + 1];
   strcpy(name, _name);
}

////////////////////////////////////////////////////////////////////////////////
// Function: Object::get_name
////////////////////////////////////////////////////////////////////////////////
char *Object::get_name(void)
{
   return name;
}

