////////////////////////////////////////////////////////////////////////////////
// Header file for Object class
////////////////////////////////////////////////////////////////////////////////

#ifndef OBJECT_H
#define OBJECT_H

#include <allegro.h>

// Types
#define TYPE_NONE 0
#define TYPE_TANK 1
#define TYPE_WEAPON 2
#define TYPE_MISSILE 3
#define TYPE_EXPLOSION 4

////////////////////////////////////////////////////////////////////////////////
// Class: Object
////////////////////////////////////////////////////////////////////////////////
class Object
{
public:
   // (Con || De)structor
   Object(void);
   virtual ~Object(void);
   // Position
   void set_x(fix _x);
   void set_y(fix _y);
   fix get_x(void);
   fix get_y(void);
   // Velocity
   void set_x_vel(fix _x_vel);
   void set_y_vel(fix _y_vel);
   fix get_x_vel(void);
   fix get_y_vel(void);
   // Angle
   void set_angle(fix _angle);
   fix get_angle(void);
   // Name
   void set_name(char *_name);
   char *get_name(void);
   // Drawing
   virtual void draw(BITMAP *b) {};
   virtual void update(void) {};
   //
   int get_count(void);
   // Existance
   int get_exist(void) { return exist; }
   void set_exist(int _exist) { exist = _exist; }
   // Type
   int get_type(void) { return type; }
   void set_type(int _type) { type = _type; }
protected:
   fix x;
   fix y;
   fix x_vel;
   fix y_vel;
   fix angle;
   char *name;
   static int count;
   int exist;
   int type;
};

#endif
