////////////////////////////////////////////////////////////////////////////////
// Header file for template class Singlist
////////////////////////////////////////////////////////////////////////////////

#ifndef SINGLIST_H
#define SINGLIST_H

#include <stdlib.h>
#include <stdio.h>

////////////////////////////////////////////////////////////////////////////////
// Class: Singlist_node
////////////////////////////////////////////////////////////////////////////////
template <class T>
class Singlist_node {
public:
   Singlist_node(T *_data) { data = _data; next = NULL; }
   ~Singlist_node(void) {}
   T *data;
   Singlist_node<T> *next;
};

////////////////////////////////////////////////////////////////////////////////
// Class: Singlist_iterator
////////////////////////////////////////////////////////////////////////////////
template <class T>
class Singlist_iterator {
public:
   Singlist_iterator(void) {}
   ~Singlist_iterator(void) {}
   Singlist_node<T> *current;
//   friend int operator==(const Singlist_node &) const;
};

////////////////////////////////////////////////////////////////////////////////
// Class: Singlist
////////////////////////////////////////////////////////////////////////////////
template <class T>
class Singlist {
public:
   typedef Singlist_node<T> *Iterator;
   Singlist(void);
   ~Singlist(void);
   Singlist_node<T> *current;
   Singlist_node<T> *head;
   int step(void);
   Singlist_node<T> *push(T *pushed);
   Singlist_node<T> *pop(T *poped);
};

////////////////////////////////////////////////////////////////////////////////
// Function: Singlist::Singlist
////////////////////////////////////////////////////////////////////////////////
template <class T>
int Singlist<T>::step(void)
{
   if (current->next != NULL) {
      current = current->next;
      return 0;
   }
   return 1;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Singlist::Singlist
////////////////////////////////////////////////////////////////////////////////
template <class T>
Singlist<T>::Singlist<T>(void)
{
   head = NULL;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Singlist::~Singlist
////////////////////////////////////////////////////////////////////////////////
template <class T>
Singlist<T>::~Singlist<T>(void)
{
   Singlist_node<T> *current_node = NULL;
   while (current_node != NULL) {
      current_node = pop(current_node->data);
   }
}

////////////////////////////////////////////////////////////////////////////////
// Function: Singlist::push
////////////////////////////////////////////////////////////////////////////////
template <class T>
Singlist_node<T> *Singlist<T>::push(T *pushed)
{
   Singlist_node<T> *previous_node = NULL;
   Singlist_node<T> *new_node = NULL;
   Singlist_node<T> *current_node = NULL;

   new_node = new Singlist_node<T>(pushed);
   previous_node = NULL;
   current_node = head;
   while (current_node != NULL) {
      previous_node = current_node;
      current_node = current_node->next;
   }
   if (previous_node == NULL) {
      new_node->next = head;
      head = new_node;
   }
   else {
      previous_node->next = new_node;
      new_node->next = current_node;
   }
   return new_node;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Singlist::pop
////////////////////////////////////////////////////////////////////////////////
template <class T>
Singlist_node<T> *Singlist<T>::pop(T *poped)
{
   Singlist_node<T> *previous_node = NULL;
   Singlist_node<T> *temp_node = NULL;
   Singlist_node<T> *current_node = NULL;

   if (poped == head->data) {
      temp_node = head;
      head = head->next;
      delete temp_node;
   }
   else {
      previous_node = head;
      current_node = head->next;
      while (current_node != NULL && current_node->data != poped) {
         previous_node = current_node;
         current_node = current_node->next;
      }
      if (current_node != NULL) {
         temp_node = current_node;
         previous_node->next = current_node->next;
         delete temp_node;
      }
   }
   return previous_node;
}

#endif
