////////////////////////////////////////////////////////////////////////////////
// Header file for Sprite class
////////////////////////////////////////////////////////////////////////////////

#ifndef SPRITE_H
#define SPRITE_H

#include <stdio.h>
#include <allegro.h>

////////////////////////////////////////////////////////////////////////////////
// Class: Vertex
////////////////////////////////////////////////////////////////////////////////
class Vertex {
public:
   int x;
   int y;
private:
};

////////////////////////////////////////////////////////////////////////////////
// Class: Sprite_frame
////////////////////////////////////////////////////////////////////////////////
class Sprite_frame {
public:
   BITMAP *image;
   Vertex focus;
   Vertex attachment;
private:
};

////////////////////////////////////////////////////////////////////////////////
// Class: Sprite
////////////////////////////////////////////////////////////////////////////////
class Sprite {
public:
   Sprite(void);
   ~Sprite(void);
   int load_file(char *_filename);
   int process_file(FILE *_file);
   void set_sprite_file_name(char *_file_name);
   void set_image_file_name(char *_file_name);
   char *get_sprite_file_name(void);
   char *get_image_file_name(void);
   void set_frame_count(int _frame_count) { frame_count = _frame_count; }
   int get_frame_count(void) { return frame_count; }
   BITMAP *get_image(int _frame) { return frames[_frame].image; }
   // drawing
   void draw(BITMAP *destination, int _x, int _y);
   // vertecies
   Vertex get_focus(int _frame) { return frames[_frame].focus; }
   Vertex get_attachment(int _frame) { return frames[_frame].attachment; }
   Vertex reposition_vertex(Vertex _vertex);
   // sizes
   int get_h(int _frame) { return frames[_frame].image->h; }
   int get_w(int _frame) { return frames[_frame].image->w; }
   // frame
   int get_frame(void) { return frame; }
   void set_frame(int _frame) { frame = _frame; }
   void next_frame(void) { if (frame < (frame_count - 1)) frame++; else frame = 0; }
   void previous_frame(void) { if (frame > 0) frame--; else frame = (frame_count - 1); }
   // scale
   fix get_scale(void) { return scale; }
   void set_scale(fix _scale) { scale = _scale; }
   // angle
   fix get_angle(void) { return angle; }
   void set_angle(fix _angle) { angle = _angle; }
protected:
   fix scale;
   fix angle;
   int frame_count;
   int frame;
   Sprite_frame *frames;
   char *sprite_file_name;
   char *image_file_name;
};

#endif
