////////////////////////////////////////////////////////////////////////////////
// Code file for Weapon class
////////////////////////////////////////////////////////////////////////////////

#include "weapon.h"
#include "main.h"
#include "math.h"

#include "gamedata.h"
#include "snd_data.h"

int Weapon::count = 0;

////////////////////////////////////////////////////////////////////////////////
// Function: Weapon::Weapon
////////////////////////////////////////////////////////////////////////////////
Weapon::Weapon(char *_sprite_file_name)
   : Object(), Sprite()
{
   set_type(TYPE_WEAPON);
   Object::angle = 0;
   count++;
   loading = 0;
   launch_power = 0;
   load_file(_sprite_file_name);
}

////////////////////////////////////////////////////////////////////////////////
// Function: Weapon::~Weapon
////////////////////////////////////////////////////////////////////////////////
Weapon::~Weapon(void)
{
   count--;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Weapon::draw
////////////////////////////////////////////////////////////////////////////////
void Weapon::draw(BITMAP *b)
{
//   rotate_sprite(b, tur, x + attachment_2_x - focus_x - 16, y + attachment_2_y - focus_y - 16, weapon->Object::get_angle().v);
   Sprite::draw(b, (int)x, (int)y);
   next_frame();
}

////////////////////////////////////////////////////////////////////////////////
// Function: Weapon::update
////////////////////////////////////////////////////////////////////////////////
void Weapon::update(void)
{
   Sprite::angle = Object::angle;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Weapon::move
////////////////////////////////////////////////////////////////////////////////
void Weapon::move(fix _angle)
{
   Object::angle += _angle;
}

////////////////////////////////////////////////////////////////////////////////
// Function: Weapon::load
////////////////////////////////////////////////////////////////////////////////
void Weapon::load()
{
   if (loading == TRUE) {
      launch_power += 0.1;
      if (launch_power > 100) {
         launch_power = 100;
      }
   }
   else {
      loading = TRUE;
      launch_power = 0.1;
   }
}

////////////////////////////////////////////////////////////////////////////////
// Function: Weapon::shoot
////////////////////////////////////////////////////////////////////////////////
void Weapon::shoot(void)
{
   Vertex focus_temp = reposition_vertex(get_focus(get_frame()));
   Vertex attachment_temp = reposition_vertex(get_attachment(get_frame()));
   Missile *new_missile = new Missile("ROCKET.SPR", x + attachment_temp.x - focus_temp.x, y + attachment_temp.y - focus_temp.y, cos(Object::angle - 64) * launch_power, sin(Object::angle - 64) * launch_power);
   objects->push(new_missile);
   loading = FALSE;
   launch_power = 0;
   play_sample((SAMPLE *)snd_data[SND_FIRE1 + rand() % 3].dat, 127, 127, 1000, 0);
}

////////////////////////////////////////////////////////////////////////////////
// Function: Weapon::collide
////////////////////////////////////////////////////////////////////////////////
int Weapon::collide(fix _x, fix _y)
{
   if ((_x > x - (get_w(get_frame()) - get_focus(get_frame()).x)) &&
       (_x < x - (get_w(get_frame()) - get_focus(get_frame()).x) + get_w(get_frame())) &&
       (_y > y - (get_h(get_frame()) - get_focus(get_frame()).y)) &&
       (_y < y - (get_h(get_frame()) - get_focus(get_frame()).y) + get_h(get_frame()))) {
      return 1;
   }
   return 0;
}

