////////////////////////////////////////////////////////////////////////////////
// Header file for Weapon class
////////////////////////////////////////////////////////////////////////////////

#ifndef WEAPON_H
#define WEAPON_H

#include <allegro.h>
#include "sprite.h"
#include "object.h"

////////////////////////////////////////////////////////////////////////////////
// Class: Weapon
////////////////////////////////////////////////////////////////////////////////
class Weapon : public Object, public Sprite
{
public:
   Weapon(char *_sprite_file_name);
   ~Weapon(void);
   void draw(BITMAP *b);
   void update(void);
   void move(fix _angle);
   void load(void);
   void shoot(void);
   int collide(fix _x, fix _y);
   int get_loading(void) { return loading; }
   void set_loading(int _loading) { loading = _loading; }
   fix get_launch_power(void) { return launch_power; }
   void set_launch_power(int _launch_power) { launch_power = _launch_power; }
protected:
   int health;
   int loading;
   fix launch_power;
   static int count;
};

#endif
